package com.xylink.sdk.test;

import com.xylink.config.SDKConfigMgr;
import com.xylink.model.PageableNemoDto;
import com.xylink.model.UserDeviceDto;
import com.xylink.sdk.enterpriseNemo.EnterpriseNemoApi;
import com.xylink.util.Result;
import org.junit.BeforeClass;
import org.junit.Test;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by changxiangyang on 2017/11/1.
 */
public class BuffetNemoTest {
    //    private String enterpriseId="12e53a6df2e91e6177e627c8e336a6888ff98104";
//    private String token = "c3671677233e213bf6b757de892635f9f394af5f40ce9706aeabfa03d2a36b8e";
    private String enterpriseId="40260e9046bae2da238ac0b0c572326b91726a83";
    private String token = "91c648e1df1bfa9d9c879c408d7583dfb7c353cadf8e15ad64031fe9a8cde098";

    @BeforeClass
    public static void setup() {
//        SDKConfigMgr.setServerHost("https://testdevsdk.xylink.com");
        SDKConfigMgr.setServerHost("http://127.0.0.1:8081");
//        SDKConfigMgr.setServerHost("https://dev.xylink.com");
    }

    @Test
    public void getPageableEnterpriseNemos(){
        EnterpriseNemoApi bun=new EnterpriseNemoApi();
        try {
            Result result = bun.getPageableEnterpriseNemos(enterpriseId, token, 1,10);
            System.out.println(result);
        }catch (IOException e){
            System.out.println("testEnd--"+e);
        }
    }

    @Test
    public void getEnterpriseDevicesPage(){
        EnterpriseNemoApi bun=new EnterpriseNemoApi();
        enterpriseId = "40260e9046bae2da238ac0b0c572326b91726a83";
        token = "91c648e1df1bfa9d9c879c408d7583dfb7c353cadf8e15ad64031fe9a8cde098";
        try {
            Result result = bun.getEnterpriseDevicesPage(enterpriseId, token, 0,40);
            System.out.println(result);
        }catch (IOException e){
            System.out.println("testEnd--"+e);
        }
    }

    @Test
    public void editDeviceName(){
        EnterpriseNemoApi bun=new EnterpriseNemoApi();
        enterpriseId = "40260e9046bae2da238ac0b0c572326b91726a83";
        token = "91c648e1df1bfa9d9c879c408d7583dfb7c353cadf8e15ad64031fe9a8cde098";
        String nemoNumber="20950641";
        String displayName="我的";
        try {
            Result result = bun.editDeviceName(enterpriseId, token, nemoNumber,displayName);
            System.out.println(result);
        }catch (IOException e){
            System.out.println("testEnd--"+e);
        }
    }

    @Test
    public void add2Enterprise(){
        EnterpriseNemoApi bun=new EnterpriseNemoApi();
        List<UserDeviceDto> userDeviceDtos =  new ArrayList<UserDeviceDto>();
        UserDeviceDto userDeviceDto = new UserDeviceDto();
        userDeviceDto.setEnterpriseId(enterpriseId);
        userDeviceDto.setDisplayName("测试添加通讯录");
        userDeviceDto.setNemoNumber("846240");
        userDeviceDtos.add(userDeviceDto);
        try {
            Result result = bun.addNemo2Enterprise(enterpriseId, token, userDeviceDtos);
            System.out.println(result);
        }catch (IOException e){
            System.out.println("testEnd--"+e);
        }
    }

    @Test
    public void removeNemoFromEnterprise(){
        EnterpriseNemoApi bun=new EnterpriseNemoApi();
        String nemoNumber = "846240";
        try {
            Result result = bun.removeNemoFromEnterprise(enterpriseId, token, nemoNumber);
            System.out.println(result);
        }catch (IOException e){
            System.out.println("testEnd--"+e);
        }
    }


    @Test
    public void get(){
        String enterpriseId = "12e53a6df2e91e6177e627c8e336a6888ff98104";
        String token = "a8208f6495ba1d468343cc63c13c5202837b5ba8614bdc699f46e91b4df09fd0";
        EnterpriseNemoApi enterpriseNemoApi=new EnterpriseNemoApi();
        try {
            Result<PageableNemoDto> nemos = enterpriseNemoApi.getPageableEnterpriseNemos(enterpriseId, token, 0, 10);
            System.out.println(nemos);
            int errStatus =nemos.getErrorStatus();
            if (errStatus<300) {
                System.out.println("getNemo测试成功！");
            }else {
                System.out.println("getNemo测试失败！");
            }
        }catch (IOException e){
            System.out.println("testEnd--"+e);
        }
    }

}
