package com.xylink.sdk.test;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.xylink.config.SDKConfigMgr;
import com.xylink.model.*;
import com.xylink.sdk.liveVideo.v3.LiveVideoApi;
import com.xylink.util.Result;
import org.junit.BeforeClass;
import org.junit.Test;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by wangdecheng on 10/05/2018.
 */
public class LiveVideoV3Test {
    private String confNo = "";
    private String enterpriseid = TestConfig.getInstance().getEnterpriseId();
    private String token = TestConfig.getInstance().getToken();
    private String confPwd = "";

    @BeforeClass
    public static void setup() {
        SDKConfigMgr.setServerHost("https://precloud.xylink.com");
//        SDKConfigMgr.setServerHost("https://testdevsdk.xylink.com");
//        SDKConfigMgr.setServerHost("http://47.95.14.108");
//        SDKConfigMgr.setServerHost("http://172.18.160.51:8080");
    }

    // TODO 云会议室号（confNo）必须有效
    @Test
    public void newLive(){
//        enterpriseid = "40260e9046bae2da238ac0b0c572326b91726a83";
//        token = "91c648e1df1bfa9d9c879c408d7583dfb7c353cadf8e15ad64031fe9a8cde098";
        enterpriseid= "a773aa1a4073a93e50d444f9a43940d4919f757e";
        token = "e44d0657674f4ea658988378720bf9c498d07e468c344035767924d5847f9fc3";
        confNo = "9092121205";
        LiveVideoApi lva=new LiveVideoApi();
        LiveVideo liveVideo=new LiveVideo();
        liveVideo.setTitle("903我的直播");
        liveVideo.setStartTime(System.currentTimeMillis() + 4*1000 * 3600);
        liveVideo.setEndTime(System.currentTimeMillis() + 20 * 1000 * 3600);
        liveVideo.setAutoRecording(false);
        liveVideo.setAutoPublishRecording(false);
        liveVideo.setLocation("喜马拉雅山");
//        liveVideo.setThirdcontentPushURL("http:127.0.0.1/content");
//        liveVideo.setThirdpeoplePushURL("http:127.0.0.1/testpeplo");
//        LiveViewerInvited liveViewerInvited = new LiveViewerInvited();
//        List<String> devices = new ArrayList<String>();
//        devices.add("60601953");
//        liveViewerInvited.setDevices(devices);
//        liveVideo.setLiveViewerInvited(liveViewerInvited);
        List<DepModel> depModels = new ArrayList<DepModel>();
        DepModel depModel = new DepModel();
        depModel.setId(1);
        depModel.setDepName("私有云3.6开发环境");

        DepModel depModel1 = new DepModel();
        depModel1.setId(3);
        depModel1.setDepName("H323");
        depModels.add(depModel);
        depModels.add(depModel1);
//        liveVideo.setDeptInvited(depModels);

        Result result=null;
        try {
            result = lva.newLiveVideo(enterpriseid, token, confNo, liveVideo);
            System.out.println("预约直播结果：" + result);
            // 成功示例：预约直播结果：{"success":true,"errorStatus":200,"data":{"enterpriseId":"12e53a6df2e91e6177e627c8e336a6888ff98104","nemoNumber":"","confNo":"910056972431","title":"我的直播","startTime":1536743674891,"endTime":1536747274891,"detail":null,"autoRecording":false,"autoPublishRecording":false,"location":"喜马拉雅山","flv":"http://prdlive.ainemo.com/prdnemo/ff808081655d38460165ccd8a9b76fad.flv?auth_key=1536833674-0-0-c43b1c89943f2b51d3c4289d2cbb8ea6","hls":"http://prdlive.ainemo.com/prdnemo/ff808081655d38460165ccd8a9b76fad.m3u8?auth_key=1536833674-0-0-23f2bd7c27842edd76d5e6f8496e1608","liveId":"ff808081655d38460165ccd8a9b76fad","status":"WAIT","viewUrl":"http://sdk.xylink.com/live/v/ff808081655d38460165ccd8a9b76fad"}}
            if(result!=null){
                System.out.println(result.getErrorStatus());
                if(result.getErrorStatus()==200){
                    LV lv= (LV) result.getData();
                    System.out.println("lv="+lv.toString());
                    // 成功示例：lv=LV{liveId='ff808081655d38460165ccd8a9b76fad', status='WAIT', viewUrl='http://sdk.xylink.com/live/v/ff808081655d38460165ccd8a9b76fad'}
                }
            }
        }catch (IOException e){
            System.out.println("testEnd--"+e);
            throw  new RuntimeException(e);
        }
    }

    @Test
    public void scheduleLive() throws IOException {
        enterpriseid= "a773aa1a4073a93e50d444f9a43940d4919f757e";
        token = "e44d0657674f4ea658988378720bf9c498d07e468c344035767924d5847f9fc3";
        confNo = "9092121205";
        LiveVideoApi lva=new LiveVideoApi();
        LiveVideo liveVideo=new LiveVideo();
        liveVideo.setTitle("903我的直播");
        liveVideo.setStartTime(System.currentTimeMillis() + 4*1000 * 3600);
        liveVideo.setEndTime(System.currentTimeMillis() + 20 * 1000 * 3600);
        liveVideo.setAutoRecording(false);
        liveVideo.setAutoPublishRecording(false);
        liveVideo.setLocation("喜马拉雅山");
//        liveVideo.setThirdcontentPushURL("http:127.0.0.1/content");
//        liveVideo.setThirdpeoplePushURL("http:127.0.0.1/testpeplo");
//        LiveViewerInvited liveViewerInvited = new LiveViewerInvited();
//        List<String> devices = new ArrayList<String>();
//        devices.add("60601953");
//        liveViewerInvited.setDevices(devices);
//        liveVideo.setLiveViewerInvited(liveViewerInvited);
        liveVideo.setDefaultLiveResolutionType("DEFAULT");
        Map extras = new HashMap();
        Map layout = new HashMap();
        layout.put("screen","landscape");

        Map people = new HashMap();
        people.put("maxCells","1");
        people.put("view","asymOverlap");
        people.put("mode","auto");
        layout.put("people",people);

        Map content = new HashMap();
        content.put("maxCells","1");
        content.put("view","asymOverlap");
        content.put("mode","auto");
        content.put("prefer",true);
        layout.put("content",content);

        Map OSD = new HashMap();
        Map nameplate = new HashMap();
        nameplate.put("enabled",true);
        OSD.put("content",nameplate);

        extras.put("layout",layout);
        extras.put("OSD",OSD);

        liveVideo.setExtras(new ObjectMapper().writeValueAsString(extras));
//        List<DepModel> depModels = new ArrayList<DepModel>();
//        DepModel depModel = new DepModel();
//        depModel.setId(1);
//        depModel.setDepName("私有云3.6开发环境");
//
//        DepModel depModel1 = new DepModel();
//        depModel1.setId(3);
//        depModel1.setDepName("H323");
//        depModels.add(depModel);
//        depModels.add(depModel1);
//        liveVideo.setDeptInvited(depModels);

        Result result=null;
        try {
            result = lva.scheduleLive(enterpriseid, token, confNo,"123456",true, liveVideo);
            System.out.println("预约直播结果：" + result);
            // 成功示例：预约直播结果：{"success":true,"errorStatus":200,"data":{"enterpriseId":"12e53a6df2e91e6177e627c8e336a6888ff98104","nemoNumber":"","confNo":"910056972431","title":"我的直播","startTime":1536743674891,"endTime":1536747274891,"detail":null,"autoRecording":false,"autoPublishRecording":false,"location":"喜马拉雅山","flv":"http://prdlive.ainemo.com/prdnemo/ff808081655d38460165ccd8a9b76fad.flv?auth_key=1536833674-0-0-c43b1c89943f2b51d3c4289d2cbb8ea6","hls":"http://prdlive.ainemo.com/prdnemo/ff808081655d38460165ccd8a9b76fad.m3u8?auth_key=1536833674-0-0-23f2bd7c27842edd76d5e6f8496e1608","liveId":"ff808081655d38460165ccd8a9b76fad","status":"WAIT","viewUrl":"http://sdk.xylink.com/live/v/ff808081655d38460165ccd8a9b76fad"}}
            if(result!=null){
                System.out.println(result.getErrorStatus());
                if(result.getErrorStatus()==200){
                    System.out.println("lv="+result.getData().toString());
                    // 成功示例：lv=LV{liveId='ff808081655d38460165ccd8a9b76fad', status='WAIT', viewUrl='http://sdk.xylink.com/live/v/ff808081655d38460165ccd8a9b76fad'}
                }
            }
        }catch (IOException e){
            System.out.println("testEnd--"+e);
            throw  new RuntimeException(e);
        }
    }

    @Test
    public void updateLive() throws IOException {
        enterpriseid= "a773aa1a4073a93e50d444f9a43940d4919f757e";
        token = "e44d0657674f4ea658988378720bf9c498d07e468c344035767924d5847f9fc3";
        confNo = "9092121205";
        LiveVideoApi lva=new LiveVideoApi();
        LiveVideo liveVideo=new LiveVideo();
        liveVideo.setTitle("我的直播");
        liveVideo.setStartTime(System.currentTimeMillis() + 1000 * 3600);
        liveVideo.setEndTime(System.currentTimeMillis() + 2 * 1000 * 3600);
        liveVideo.setAutoRecording(false);
        liveVideo.setAutoPublishRecording(false);
        liveVideo.setLocation("喜马拉雅山");
        liveVideo.setDefaultLiveResolutionType("DEFAULT");
        Map extras = new HashMap();
        Map layout = new HashMap();
        layout.put("screen","landscape");

        Map people = new HashMap();
        people.put("maxCells","2");
        people.put("view","asymOverlap");
        people.put("mode","auto");
        layout.put("people",people);

        Map content = new HashMap();
        content.put("maxCells","2");
        content.put("view","asymOverlap");
        content.put("mode","auto");
        content.put("prefer",true);
        layout.put("content",content);

        Map OSD = new HashMap();
        Map nameplate = new HashMap();
        nameplate.put("enabled",true);
        OSD.put("content",nameplate);

        extras.put("layout",layout);
        extras.put("OSD",OSD);

        liveVideo.setExtras(new ObjectMapper().writeValueAsString(extras));

//        liveVideo.setThirdcontentPushURL("http:127.0.0.1/contentedit/1111");
//        liveVideo.setThirdpeoplePushURL("http:127.0.0.1/testpecontenteditplo/11111");
//        List<DepModel> depModels = new ArrayList<DepModel>();
//        DepModel depModel = new DepModel();
//        depModel.setId(1);
//        depModel.setDepName("私有云3.6开发环境");
//
//        DepModel depModel1 = new DepModel();
//        depModel1.setId(3);
//        depModel1.setDepName("H323");
//
//        DepModel depModel2 = new DepModel();
//        depModel2.setId(7);
//        depModel2.setDepName("123");
//        depModels.add(depModel);
//        depModels.add(depModel1);
//        depModels.add(depModel2);
//        liveVideo.setDeptInvited(depModels);
        Result result=null;
        try {
            result = lva.updateLive(enterpriseid, token, confNo,"123456","9680e3b4777190fb0177b91ee81300ba", liveVideo,false);
            System.out.println("修改直播结果：" + result);
        }catch (IOException e){
            System.out.println("testEnd--"+e);
            throw  new RuntimeException(e);
        }
    }

    @Test
    public void getLive(){
//        enterpriseid= "0503a7bd0c5f9d6b763fc359f2a6db9ea449c83a";
//        token = "56aeacb062b7d8fa69a5b3136b422fd276d443652c5cef89aaa1751589448369";
        enterpriseid= "a773aa1a4073a93e50d444f9a43940d4919f757e";
        token = "e44d0657674f4ea658988378720bf9c498d07e468c344035767924d5847f9fc3";
        confNo = "9092121205";
        confPwd= "123456";
        LiveVideoApi lva=new LiveVideoApi();
        Result result=null;
        try {
            result = lva.getLive(enterpriseid, token, confNo,confPwd,"9680e3b4777190fb0177b91ee81300ba",true);
            System.out.println("获取直播结果：" + result);
        }catch (IOException e){
            System.out.println("testEnd--"+e);
            throw  new RuntimeException(e);
        }
    }

    @Test
    public void getLiveVideoListByIds(){
        enterpriseid= "a773aa1a4073a93e50d444f9a43940d4919f757e";
        token = "e44d0657674f4ea658988378720bf9c498d07e468c344035767924d5847f9fc3";
        LiveVideoApi lva=new LiveVideoApi();
        List<ConfLiveVideoRequest> confLiveVideoRequests = new ArrayList<ConfLiveVideoRequest>();
        ConfLiveVideoRequest confLiveVideoRequest = new ConfLiveVideoRequest();
        confLiveVideoRequest.setConfNo("9092121205");
        confLiveVideoRequest.setLiveId("9680bf34776d18ee01777162433400d3");
        confLiveVideoRequests.add(confLiveVideoRequest);
        ConfLiveVideoRequest confLiveVideoRequest2 = new ConfLiveVideoRequest();
        confLiveVideoRequest2.setConfNo("9092121205");
        confLiveVideoRequest2.setLiveId("9680bf34776d18ee017771686ac200da");
        confLiveVideoRequests.add(confLiveVideoRequest2);
        Result result=null;
        try {
            System.out.println("param="+confLiveVideoRequests.toString());
            result = lva.getLiveVideoListByIds(enterpriseid,token,confLiveVideoRequests);
            System.out.println("获取直播结果：" + result);
        }catch (IOException e){
            System.out.println("testEnd--"+e);
            throw  new RuntimeException(e);
        }
    }
    /**
     * 开始结束直播
     * TODO 开始直播前，保证已经呼起云会议号,当前示例呼起 910056972431
     */
    @Test
    public void goLive(){
        enterpriseid = "0503a7bd0c5f9d6b763fc359f2a6db9ea449c83a";
        token = "56aeacb062b7d8fa69a5b3136b422fd276d443652c5cef89aaa1751589448369";
        confNo = "9010078460";
        confPwd= "000000";
        Result result = null;
        LiveVideoApi lva=new LiveVideoApi();
        String liveId = "2c94bb04704ec68f0170754930b65c68";
        Status status = new Status();
        status.setStatus("start");
        try{
            result = lva.controlLive(enterpriseid, token, confNo, confPwd, liveId, status);
            System.out.println("result：" + result);
        }catch(Exception e){
            System.out.println(e);
        }
    }
    @Test
    public void getEnterpriseLivesPageByStatus(){
        enterpriseid= "a773aa1a4073a93e50d444f9a43940d4919f757e";
        token = "e44d0657674f4ea658988378720bf9c498d07e468c344035767924d5847f9fc3";
        LiveVideoApi lva=new LiveVideoApi();
        try{
            Result result = lva.getEnterpriseLivesPageByStatus(enterpriseid, token, 0,"all",0,20,true);
            System.out.println(result);
        }catch(Exception e){
            System.out.println(e);
        }
    }

}
