package com.xylink.sdk.test;


import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.xylink.config.SDKConfigMgr;
import com.xylink.model.*;
import com.xylink.sdk.dating.WechatApi;
import com.xylink.sdk.wechat.MiniProgramApi;
import com.xylink.util.Result;
import org.junit.BeforeClass;
import org.junit.Test;

import java.io.IOException;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;

import static org.junit.Assert.fail;

/**
 * Created with IntelliJ IDEA.
 * Description:
 * User: gzm
 * Date: 2018-12-08
 */
public class WechatTest {

//    private String enterpriseid= TestConfig.getInstance().getEnterpriseId();
//    private String token = TestConfig.getInstance().getToken();

    private String enterpriseid= "f4a9835d8e81671a997e0f1a23dc48194d3ab150";
    private String token = "211532901cd5def05dc294589fa268e3f2478938e28542ed8ce48dadb04f1738";

//txdev
//    private String enterpriseid= "40260e9046bae2da238ac0b0c572326b91726a83";
//    private String token = "91c648e1df1bfa9d9c879c408d7583dfb7c353cadf8e15ad64031fe9a8cde098";

    private String appId = "BNNVNNNNNNHNT";
    private String userName = "+86-10018971442";
    private String mpToken = "22c1f1868be14597a564e46ccd2ff407";

    @BeforeClass
    public static void setup() {
        SDKConfigMgr.setServerHost("https://sdk.xylink.com");
//        SDKConfigMgr.setServerHost("http://127.0.0.1:8081");
    }

    @Test
    public void batchUser() {
        enterpriseid = "7daf952d71c87b962ea3dc3209b3969d2c75c4d0";
        token = "f3ff9ad1dbbf80f553dceb810c32d3092a8da7477ee2ebff568fe6a3646b208b";
        appId = "BNNIVTVVNZNNT";
        MiniProgramApi miniProgramApi = new MiniProgramApi();
        try {
            Result<List<SdkMiniProgramUserDto>> result = miniProgramApi.batchUser(enterpriseid,token,appId);
            System.out.println(result.getData());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void getToken() {
        MiniProgramApi miniProgramApi = new MiniProgramApi();
        SdkMiniProgramTokenRequestModel sdkMiniProgramTokenRequestModel = new SdkMiniProgramTokenRequestModel();
        sdkMiniProgramTokenRequestModel.setAppId(appId);
        sdkMiniProgramTokenRequestModel.setUserName(userName);
        try {
            Result result = miniProgramApi.getToken(enterpriseid,token,sdkMiniProgramTokenRequestModel);
            MiniTokenModel miniTokenModel = new ObjectMapper().readValue(result.getData().toString(),MiniTokenModel.class);
            System.out.println(miniTokenModel.getUserName());
            mpToken = miniTokenModel.getToken();
            System.out.println(mpToken);
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void tokenLogin() {
        MiniProgramApi miniProgramApi = new MiniProgramApi();
        SdkMiniProgramLoginRequest sdkMiniProgramLoginRequest = new SdkMiniProgramLoginRequest();
        sdkMiniProgramLoginRequest.setToken(mpToken);
        try {
            Result result = miniProgramApi.tokenLogin(enterpriseid,token,sdkMiniProgramLoginRequest);
            MIniUserInfoModel mIniUserInfoModel = new ObjectMapper().readValue(result.getData().toString(),MIniUserInfoModel.class);
            System.out.println(mIniUserInfoModel.getId());
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void getUsers() {
        MiniProgramApi miniProgramApi = new MiniProgramApi();
        enterpriseid = "7daf952d71c87b962ea3dc3209b3969d2c75c4d0";
        token = "f3ff9ad1dbbf80f553dceb810c32d3092a8da7477ee2ebff568fe6a3646b208b";
        appId = "BNNIVTVVNZNNT";
        try {
            Result result = miniProgramApi.getUsers(enterpriseid,token,appId);
            List<MIniUserModel> ls =  new ObjectMapper().readValue(result.getData().toString(),new TypeReference<List<MIniUserModel>>(){});
            System.out.println(ls.size());
//            for (int i = 0; i < 20; i++) {
//                System.out.println("--------------------");
//                MIniUserModel mIniUserModel = ls.get(i);
//                userName = mIniUserModel.getUserName();
//                getToken();
//                tokenLogin();
//            }
        } catch (IOException e) {
            fail(e.getMessage());
        }
    }

    @Test
    public void remindmeeting(){
        Set<String> ps = new TreeSet<String>();
        Set<String> sps = new TreeSet<String>();
        WechatApi sma=new WechatApi();
        ReminderMeeting reminderMeeting=new ReminderMeeting();
        reminderMeeting.setTitle("testtesttest");
        reminderMeeting.setStartTime(System.currentTimeMillis() + (1000 * 60 * 1));
        reminderMeeting.setEndTime(System.currentTimeMillis() + (1000 * 60 * 60));
        reminderMeeting.setAddress("地中海");
        reminderMeeting.setAutoInvite(1);
        reminderMeeting.setPassword("0000");
        reminderMeeting.setConferenceControlPassword("111111");
        reminderMeeting.setMeetingRoomType(1);
        reminderMeeting.setAutoRecord(0);
        reminderMeeting.setParticipants(ps);
        reminderMeeting.setSingleRecordParticipants(sps);
        reminderMeeting.setConferenceNumber("9797");
        try {
            Result result = sma.remindMeeting(enterpriseid, token, reminderMeeting,0,100249114);
            System.out.println(result);
            //如成功后的一个示例：{"success":true,"errorStatus":200,"data":{"meetingId":"ff80808165a02ba20165cc92ef9b542c","meetingRoomNumber":"956401821"}}
        }catch (IOException e){
            System.out.println("testRemindMeeting--"+e);
        }
    }

}
